




                     BC - Programmable Scientific Calculator
                                 by John Venable 1991
                             copyright John Venable 1991




















    page 2

                                 What is BC?

         BC is a programmable scientific calculator for the command
     line. It allows you to evaluate expressions such as 12*12.34,
     sin 43, and so on from the command line. You may also use it
     through redirection or piping to operate on text files holding
     similar information. It is also a simple adding machine, allowing
     you to add numbers or expressions either from the keyboard or a file.
     You can also program BC in a simple language similar to BASIC.

         BC is a user supported program. No payment is required to use
     the program, and you are granted permission to modify it according
     to your needs. Full C source code is provided. However, you may
     not sell this program, nor may you distribute this program in a
     modified form. (However, if you do modify it and wish to distribute
     it, you may contact me for permission to do so.)
     You may freely give the program away, but you may not charge anything
     more than the cost of duplicating the media.

         This program comes with no warranty, and is distributed
     "AS IS". I make no claim as to its ability to produce usefull
     results, and will accept no liability for its failure. The full
     risk of using this program falls upon the user.

         If this program is useful to you send me whatever you
     think it is worth to you. This is voluntary, and not a condition to
     using the program.

         If you find any bugs, or have any suggestions, please write me:

                         John Venable
                         975 Cosgrave
                         Winnemucca, Nevada 89445

         As I am doing this on my own time, I cannot support this product on
         the phone. If a bug is found (If - ha ha) I will do my best to
         correct it if it is called to my attention.


     page 3

                         Using BC from the command line

         To use BC from the command line just type BC and the expression
     you wish to evaluate. For instance, to find 10 + 10
                         C:>bc 10+10
                         20
                         C:>
     The result of the calculation will be stored on disk so that you can
     use it in another calculation as so:
                         C:>bc mem / 5
                         4
                         C:>

     MEM is a keyword which always holds the result of the last calculation.

     The functions available for use in BC are described in the section on
     programming BC.

         The command line options for using BC are:

                         -?                 Print a help screen.
                         -f FILE.BC      Run a program held in FILE.BC
                         -a              Run as a simple adding machine.




                         Using BC from the standard input

         If you type "BC" without any arguments, BC reads the standard
     input and evaluates it. The input into bc can be from the keyboard
     or a redirected file. For instance typing:

                         C:>bc

     would cause BC to read the input from the keyboard and evaluate it until
     an error was read, a control Z was entered, or the keyword END was
     encountered. The result of the calculation from each line is stored in
     the MEM variable. MEM cannot be assigned to, only read from. When the
     program exits, MEM will be stored in the directory pointed to by the
     environment variable TEMP or TMP. If no such variable exists, the result
     will be stored in the current directory.

     page 4

         You can use parenthesis to dictate the order of evaluation. You
     may nest them to almost any level.

         If numbers are encountered on a input line without any seperating
     operators, the numbers will be added together. For instance,

                                 C:>bc
                                 10 20 30 40
                                 100
         is the same as:
                                 10+20+30+40
                                 100


         You may store results in variables. The rules for variables are:

             1. The may only consist of alphabetic characters (no numbers,
                underscores, or any other non-alphabetic character).
             2. They may not duplicate a built in keyword such as SIN or MEM.
             3. Arrays do not need to be declared, but may have only one
                integer dimension. Arrays use square brackets '[]' to hold
                the subscript. i.e. a[4], total[9], etc.
             4. Variables and arrays need not be declared as all are of
                a double floating point type. But before they are used they
                should have a value assigned them. Failing to do so will
                result in a non-fatal error message being issued. When a
                un-assigned variable is encountered, the error message is
                issued and then the variable is entered into the variable
                table with the value of zero.
             5. Variables are case insensitive.
             6. You may use no more than 300 variables, including all array
                members.
             7. Arrays may start at any number.
             8. Variables are significant to 60 characters.
             9. Using a variable on a line by itself will cause the value of
                the variable to be printed.

         Here are some examples:

             a -         legal variable
             alphavar -     legal variable
             Z1 -        illegal variable - will concatenate the contents of
                          'Z' and the number 1.
             AbCdE -        legal variable
             Cos -        illegal variable - duplicates keyword.
             a[1] -        legal array
             abc[43] -    legal array
             var[sin 4]  legal array but subscript is converted to an integer
             loan[5] -    illegal array - duplicates keyword.
             a_var -     illegal variable - no underscores allowed.

     page 5

         To assign a value to a variable simply use a equals sign as so:

                         height = hypot 23 43
                         a = 7
                         b = a * height

         To save the values and names of variables you have created use the
     SAVE keyword. To save the variables in a filename called vars.001 type:

                         save vars.001

     The variables will be saved in a text format style that may be edited
     and modified manually with a text editor.

     If the filename is illegal or some other problem prevents the writing of
     the file an error message will be issued.

     To recall the previously saved variables use the LOAD keyword as so:

                         load vars.001

     If the file cannot be found, or some other error takes place, an error
     message will be issued.

     To dump the names and values of the variables entered, enter the keyword
     dump. So, if you have two variables, named a and b, then dump will
     produce:

                         dump
                         a = 4.0000000
                         b = 5.0000000

         You may execute a DOS command or shell out to DOS by using the SHELL
     command. For instance:

                         shell dir

     will print out the current directory.

                         shell

     will run a subshell from within the program. Typing "EXIT" will return
     you to BC.

         If you wish to evaluate a file containing expressions, either pipe
     the contents of a file to BC or redirect the standard input from a file.
     For example, if you had a file named TRIG.DAT that you wish evaluated,
     you could do so like this with a pipe:

                         C:>type trig.dat | bc

     or like this with redirection:

                         C:>bc < trig.dat


     page 6
                             Using BC in add mode.

         To use BC as a simple adding machine, simply invoke it with the
     -a command line option as so:

                             bc -a

     When this is done, BC will start to read the standard input, evaluating
     each line as read, and totaling it. No output is produced until the end
     of the input is reached, either the end of a redirected file, or a
     control Z character read from the keyboard. To produce a subtotal while
     entering in numbers from the keyboard, enter a lone '=' equals sign.
     This will cause BC to output the subtotal of all input but will still
     preserve the running total. If you wish to see the total and clear the
     the running total, enter two "==" equal signs. This will produce a total
     and clear the running total to zero. So then:

                         C:>bc -a
                         1
                         2
                         3
                         4
                         5
                         6
                         7
                         8
                         9
                         <CTRL Z>
                         45
                         C:>

         Note that entering numbers without any operators on a line will
     cause BC to total the numbers as if they were separated by '+' plus
     operators. So then:

                         C:>bc 1 2 3 4 5 6 7 8 9
                         45
                         C:>

                         is equivalent to:

                         C:>bc 1+2+3+4+5+6+7+8+9
                         45
                         C:>


         In add mode BC will evaluate expressions and add them as well as
     simple numbers.


     page 7
                                 Programming BC

         The programming language built into BC is similar to BASIC
     with some features of C thrown in. The language has twelve keywords,
     twelve operators, thirtythree functions and two data types.
     The language is interpreted, and is suitable for automating repetitive
     input operation to the calculator and providing a user friendly shell
     for the command line. The input to a program can be redirected from
     the standard input.

         To write a program for the calculator you will need a text editor,
     ( not a word processor that inserts control codes ) such as
     the edit program in DOS 5 or (shudder) edlin.

         To run a program invoke BC as so:  bc -f <filename.ext>. If
     the filename is not found or invalid the program will issue an
     error message and exit.

         The structure of a BC program resembles BASIC. The rules that
     must be observed are:
         1...  Only one statement per line are allowed.
         2...  Keywords, functions, and variables are not case sensitive.
         3...  An IF statement must be terminated by a corresponding ENDIF
                         if a > 4
                             goto start
                         endif
         4... A WHILE statement must be terminated by a
              corresponding ENDWHILE.
                         a = 1
                         while a < 10
                             print a
                             a = a + 1
                         endwhile
         5... Anything after an apostrophe is ignored
                         'this is a comment
                         a = 4 ' so is this
         6... You can print the value of a variable by using the print
              statement or by simply putting the variables name on a
              line by itself. Note that the formatting punctuation only works
              with a print statement.
                          print a, b
                          a
         7... The input statement will accept anything that would be legal
              as input to the calculator. If the input statement receives as
              input a operation such as print which doesn't return a value
              the input statement will return a zero.
                          ( 5 * 3)/ 2  returns 7.5
                         print "hello" returns 0
         8... The maximum number of programming statements is 300. (this can
              be modified by recompiling the program with a different value.)
         9... Indentation is optional but nice.
        10... If you refer to a variable before assigning a value to it,
              the program will notify you that you have not yet assigned
              a value to this variable. It will then enter the variable
              into the variable table with a value of zero. But any operation
              on the line with the unassigned variable will be ignored. In
              a loop the first time a unassigned variable is encountered
              the line in which it is will not be executed. If x has yet no
              value then for:
                              a = x + 1
              "a" will not be assigned any number from this line.

    page 8

        11... Variables must only contain letters - no numbers are allowed.
              If you use a number in a variable, such as a2 or amount3, the
              program will issue no error, but will assume that you wish to
              concatenate the variable with the following number.
              If a = 2, then a2 will evaluate out to 22, not as a separate
              variable. This is especially important to watch for if you
              are converting BASIC programs.
        12... Only single dimensional arrays are supported. Arrays do not
              need to be dimensioned, and the array subscript doesn't need
              to be in any order. For instance,
                              a[10], a[-34], a[10233]
              will all be accepted as valid members of the array a. Arrays
              have no upper or lower bounds, but the subscript must be an
              integer. If an expression is used as a array subscript, the
              result will be converted to an integer before use.
              For instance:
                              a[ 3/2], a[ sinh 1.2], a[ 1.999]
              will all refer to a[1].


     page 9

                                 BC Operators

     !=     Not equal to. Can only be used in IF and While statements.
     *      Multiplication.
     +      Addition.
     -      Subtraction and unary negation.
     /      Division.
     <      Less than. Can only be used in IF and While statements.
     <=     Less than or equals to. Can only be used in IF and While
            statements.
     =      Assignment of a value to a variable and to test equality, as in
            BASIC.
     >      Greater than. Can only be used in IF and While statements.
     >=     Greater than or equals to. Can only be used in IF and While
            statements.
     ,      Comma - separator in print statements causing tabbing over
            one tabstop.
     ;      Semi-colon -separator in print statements causing suppression
            of newline character.
     '      Apostrophe - program remark as in BASIC. Can be on a line by
            itself, or following a program statement. Anything following
            it will be ignored.



     page 10

                        BC Functions and Keywords


                                 ---A---
     ______________________________________________________________________
     abs        Function
     ----------------------------------------------------------------------
     Returns: absolute value.
     Range:    any number.
     Arguments: one.
                 abs -8  = 8
                 abs (4) = 4

     ______________________________________________________________________
     acos    Function
     ----------------------------------------------------------------------
     Returns: the arc cosine in radians.
     Range:  -1 to 1
     Arguments: angle in radians.
                 acos .5 = 1.047197551
                 acos (-.5) = 2.094395102

     ______________________________________________________________________
     asin    Function
     ----------------------------------------------------------------------
     Returns: the arc sine in radians.
     Range:  -1 to 1
     Arguments: angle in radians.
                 asin .5 = 0.5235987756
                 acos (-.5) = -0.5235987756


     ______________________________________________________________________
     atan    Function
     ----------------------------------------------------------------------
     Returns: the arc tangent in radians.
     Range:  -1 to 1
     Arguments: angle in radians.
                 atan .5 = 0.463647609
                 atan (-.5) = -0.463647609



     page 11

                                 ---C---
     ______________________________________________________________________
     ceil    Function
     ----------------------------------------------------------------------
     Returns: the smallest integer value greater than or equal to argument.

     Range: any number.
     Arguments: one.
                 ceil .5 = 1
                 ceil 5.1 = 6



     ______________________________________________________________________
     cexp    Function
     ----------------------------------------------------------------------
     Returns: 10 to the xth power ( common exponent).
     Range: any number.
     Arguments: one.
                 cexp 3 = 1000
                 cexp (.5) = 3.16227766

     ______________________________________________________________________
     cos     Function
     ----------------------------------------------------------------------
     Returns: cosine in radians
     Range: any number.
     Arguments: angle in radians.
                 cos 4 = -0.6536436209
                 cos (-1) = 0.5403023059

     ______________________________________________________________________
     cosh    Function
     ----------------------------------------------------------------------
     Returns: hyperbolic cosine in radians.
     Range: any number.
     Arguments: angle in radians.
                 cosh 3 = 10.067662
                 cosh -5 = 74.20994852

     ______________________________________________________________________
     cot     Function
     ----------------------------------------------------------------------
     Returns: cotangent in radians.
     Range: any number excluding zero.
     Arguments: angle in radians.
                 cot 4 = 0.863691154
                 cot (-2) = 0.457657554

     ______________________________________________________________________
     csc     Function
     ----------------------------------------------------------------------
     Returns: cosecant in radians
     Range: any number.
     Arguments: angle in radians.
                 csc 6 = -3.578899547
                 csc -1 = -1.188395106



     page 12

                                 ---D---

     ______________________________________________________________________
     deg     Function
     ----------------------------------------------------------------------
     Returns: converts radians into degrees.
     Range: any number.
     Arguments: angle in radians.
                 deg( 3/pi) = 54.713439128
                 deg pi = 180

     ______________________________________________________________________
     dump     Keyword
     ----------------------------------------------------------------------
     Returns: nothing.
     Arguments: none.
     Notes: dump prints the name and value of each variable in the variable
            table.





     page 13
                                 ---E---
     ______________________________________________________________________
     end     Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Causes program to terminate and return to operating
     system.
     Range: none.
     Arguments: none.
     Usage:
                     'demonstrates use of end.
                     a = 0
                     while a != -1
                         input " -1 to end, any other number to
     continue " a
                         print "sin" a "=" sin a
                     endwhile
                     end

     ______________________________________________________________________
     endif   Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Terminates IF statement.
     Range: none.
     Arguments: none.
     Note: if the matching endif cannot be located the program will abort
           with an error message.
     Usage:
                     'demonstrates use of endif
                     start:
                     input " Input number " a
                     if a = 0
                         print "You cannot find the tangent of zero"
                         goto start
                     endif
                     print "The tangent of" a "is" tan a
                     goto start



	 page 14
     ______________________________________________________________________
     endwhile   Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Terminates WHILE statement.
     Range: none.
     Arguments: none.
     Notes: if the matching endwhile cannot be located, the program will
     abort
            with an error message.
     Usage:
                     'Demonstrates while and endwhile
                     a = 0
                     print "Multiplication Table to ten"
                     while a <= 10
                         print "------" a"------"
                         b = 0
                         while b <= 10
                             print a "X" b "=" b*a
                             b = b + 1
                         endwhile
                         a = a + 1
                         print
                     endwhile
                     end


     ______________________________________________________________________
     exp     Function
     ----------------------------------------------------------------------
     Returns: e to the xth power where e = 2.718281828
     Range: any number.
     Arguments: any number.
                     exp 4 = 54.59815003
                     exp 0.6931471806 = 2

     page 15

                                 ---F---
     ______________________________________________________________________
     fact    Function
     ----------------------------------------------------------------------
     Returns: Factorial of the argument.
     Range: 0 - 38 ( higher if recompiled using the scientific notation
     option)
     Arguments: one integer.
                     fact 4 = 24
                     fact 10 = 3628800

     ______________________________________________________________________
     fract   Function
     ----------------------------------------------------------------------
     Returns: the fractional part of the argument.
     Range: any number.
     Arguments: one.
                     fract 1.234 = .234
                     fract pi = .14152654




     page 16
                                 ---G---
     ______________________________________________________________________
     goto    Keyword
     ----------------------------------------------------------------------
     Returns: nothing.  Causes program to continue execution at <label:>
     Range: none.
     Arguments: a alphabetic string or a number followed by a colon.
     Notes: each label must be on a line by itself. If the label cannot be
     found,
            the program will abort with an error message.
     Usage:
                     'demonstrates the use of goto
                     start: ' this is a line label
                     a = 0
                     input "what is your age" age
                     print "you are " age * 12 " months old"
                     input "0 to go again any other number to exit" a
                     if a = 0
                         goto start
                     endif
                     end




     page 17
                                 ---H---
     ______________________________________________________________________
     help    Keyword
     ----------------------------------------------------------------------
     Returns: a help screen. The same effect in direct mode is caused by a
     ? mark.
     Range: none.
     Arguments: none.
     Usage:
                     help

     ______________________________________________________________________
     hypot   Function
     ----------------------------------------------------------------------
     Returns: the hypotenuse of a right triangle
     Range: any sized right triangle
     Arguments: two - side a and side b of a right triangle.
     Note: do not enclose the two arguments in parentheses as this will
           cause them to be evaluated as one number and the
           program will abort with an error message.
           They must be separated with either a space or a comma.

                     hypot 3 4 = 5
                     hypot 12, 16 = 20




     page 18

                                 ---I---
     ______________________________________________________________________
     if      Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Controls program flow based on conditional
     operators.
     Range: none.
     Arguments: two expressions separated by a conditional operator.
     Notes: If must have two arguments separated by the conditional
            operator. The statement " if a "  is illegal. It must be
            in the form of "if a = 0" or "if a > 1" and so on.
            There must be nothing after the if statement on the line.
            If the if statement is true, then the program execution
            follows on the line after the if statement. If it evaluates
            as false, then the program starts execution on the line after
            the matching "endif" statement. If the condition is false and a
            matching endif cannot be found, the program will abort with an
            error message.
     Usage:
                     'demonstrates the usage of if
                     'and simulates the logical AND
                     'and logical OR
                     input "input a number "; a
                     ' here is a logical AND
                     if a > 100
                         if a < 200
                             print "number is between 101 and 199"
                             goto last
                         endif
                     endif
                     ' here is a logical OR
                     if a < 100
                         gosub message
                         goto last
                     endif
                     if a > 200
                         gosub message
                         goto last
                     endif

                     print "you entered either 100 or 200 exactly"
                     last:
                     end
                     message:
                     print "you are out of range"
                     return


     page 19
     ______________________________________________________________________
     input   Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Assigns a variable with an amount typed in at the
     keyboard or redirected to the standard input.
     Range: none.
     Arguments: optional string prompt and a required variable.
     Notes: The input function will accept either the keyboard input or if
            you have redirected the standard input it will accept that until
            it reaches a END OF FILE marker (DOS - control Z UNIX - control D).
            The input received will be parsed and will be treated just like
            input directly into the calculator. For instance, the number
            "50" and the expression "(3+2) * cexp 1" will work exactly the
            same. If the input is a empty line the variable will be set to
            zero. Any expression which would cause an error message in the
            calculator will cause the same error in an input statement and
            abort the program. The use of a semi-colon or comma after the
            prompt string is optional and has no effect.
     Usage:
                         'demonstrates the use of input
                         input "variable a"; a
                         input b
                         print " a =" ;a
                         print "b = " b

     ______________________________________________________________________
     int     Function
     ----------------------------------------------------------------------
     Returns: the truncated integer part of a number.
     Range: any number.
     Arguments: one.
                 int 3.5 = 3
                 int -3.5 = -3



     page 20
                                 ---L---
     ______________________________________________________________________
     ln      Function
     ----------------------------------------------------------------------
     Returns: the natural (base e) logarithm
     Range: any number greater than zero.
     Arguments: one.
     Notes: Zero or a negative number will cause an error and abort the
            program.
                 ln 4 = 1.386294361
                 ln 1000 = 6.907755279

     ______________________________________________________________________
     load    Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Loads variable table from disk.
     Range: valid file names.
     Arguments: one file name.(can include the path - defaults to current
                directory)
     Notes: If the file name is not valid, the program will issue an error
            message and continue.
     Usage:
                         load file.nam

     ______________________________________________________________________
     loan    Function
     ----------------------------------------------------------------------
     Returns: payment amount on a loan.
     Range: any amount.
     Arguments: Three:  the amount of the loan, the interest rate, number
                of months
     Notes: You must not enclose the three arguments in parentheses else
            the program will issue a error message and abort. The interest
            rate must be in percentage form, ie; 10.9 not 0.109.
     Usage:
                         loan 1000 10 12
                         87.91588733
                         loan 14000, 9.5, (5*12)
                         294.026058336

     ______________________________________________________________________
     log     Function
     ----------------------------------------------------------------------
     Returns: natural base 10 logarithm
     Range: any number greater than zero
     Arguments: one.
     Notes: Any number zero or less, will cause an error message and abort
            the program.
                            log 1000 = 3
                         log 300 = 2.477121255



     page 21

                                 ---M---
     ______________________________________________________________________
     mem     Function
     ----------------------------------------------------------------------
     Returns: The result of the last calculation.
     Range: none.
     Arguments: none.
     Notes: The mem function always holds  the result of the last
            calculation. When the program starts up, it looks to see
            if you have defined either a TMP or TEMP system variable in
            your autoexec.bat file. If so, it looks there for a file
            called ~~~~BC~~.TMP. If it finds it, it loads it as the value
            of mem. If there is no temp directory defined it looks in the
            current directory. If it cannot find it there, it just sets
            mem to zero and continues. When the program exits, it saves
            the result of the last calculation in either the temp directory
            if it exists, or in the current directory.
     Usage:
                         mem / 3
                         mem + mem
                         etc.

     ______________________________________________________________________
     mod     Function
     ----------------------------------------------------------------------
     Returns:  a modulo b.
     Range: any numbers b not being zero
     Arguments: two.
     Notes: You must not surround a and b with parentheses or the program
            will issue an error message and abort.

                            mod 5 3 = 2
                         mod 6.3, 5.2 = 1.1
                         mod -17 7 = 4




     page 22

                                 ---P---
     ______________________________________________________________________
     pi      Constant
     ----------------------------------------------------------------------
     Returns: 3.141592654
     Range: none.
     Arguments: none.

     ______________________________________________________________________
     print   Keyword
     ----------------------------------------------------------------------
     Returns: nothing. Prints strings and variables.
     Range: any quoted strings and any valid expressions.
     Arguments: variable number of strings and expressions.
     Notes:  The print statement is much like its BASIC equivalent. A
             quoted string is just directly output. An expression, such
             as (5*2) is first evaluated and then printed. If a comma
             separates the arguments the following argument is printed
             in the next tab stop. If a semi-colon follows the last argument
             no newline is printed so following output is printed on the
             same line. If no punctuation is between the arguments
             everything is printed on the same line.
     Usage:
                         print "hello"
                         hello
                         print "5 X 3 =" 5*3
                         5 X 3 = 15
                         print, "tab1", "tab2"
                             tab1    tab2

     ______________________________________________________________________
     purm    Function
     ----------------------------------------------------------------------
     Returns: the permutations possible with x and y
     Range: positive numbers - large numbers may cause overflow errors.
     Arguments: two - x and y.
     Notes: for instance, if you wished to find all the ways eight people
            could fill eight seats you would use purm 8 8. To find all
            the ways eight people could be seated given only four seats
            you would use purm 8 4.

                                purm 8 8 = 40320
                             purm 8 4 = 1680



     page 23

                                 ---R---
     ______________________________________________________________________
     rad     Function
     ----------------------------------------------------------------------
     Returns: convert degrees into radians.
     Range: any angle in degrees.
     Arguments: one.
                             rad 360 = 6.283185308
                             rad 180 = 3.141592654

     ______________________________________________________________________
     rand    Function
     ----------------------------------------------------------------------
     Returns: a random number from 0 to 1
     Range: none.
     Arguments: none.
                     rand = .39203
                     rand = .4567675

     ______________________________________________________________________
     recip   Function
     ----------------------------------------------------------------------
     Returns: the reciprocal of the number (1/x) or 1^-1
     Range: any number.
     Arguments: one.
                         recip .5 = 2
                         recip 2 = .5
     ______________________________________________________________________
     remain  Function
     ----------------------------------------------------------------------
     Returns:  remainder a/b
     Range: any numbers b not being zero
     Arguments: two.
     Notes: You must not surround a and b with parentheses or the program
            will issue an error message and abort. Note that this function
            is not identical with the mod function.

                            remain 5 3 = 2
                         remain 6.3, 5.2 = 1.1
                         remain -17 7 = -3

     ______________________________________________________________________
     root    Function
     ----------------------------------------------------------------------
     Returns: the xth root of y
     Range: any numbers x not being zero
     Arguments: x and y.
     Notes: Do not enclose the two arguments with parentheses as this will
            cause an error.
                         root 3 125 = 5
                         root 7 20 = 1.534127405



     page 24
                                 ---S---
     ______________________________________________________________________
     save    Keyword
     ----------------------------------------------------------------------
     Returns: nothing.
     Range: valid filename.
     Arguments: one valid filename.
     Notes: This will save all variables you have created to disk. The disk
            file is in text form and can be modified with a text editor.
     Usage:
                         save variable.mem
                         save constant.mem

     ______________________________________________________________________
     sec     Function
     ----------------------------------------------------------------------
     Returns: the secant of the angle in radians.
     Range: any angle in radians.
     Arguments: one.
                         sec 12 = 1.185039176
                         sec .5 = 1.139493927
     ______________________________________________________________________
     shell   Keyword
     ----------------------------------------------------------------------
     Returns: nothing useful.
     Arguments: one.
     Notes: Shell will execute a DOS command if one is given or will shell
            out to DOS if no command string is given. When shell out to DOS
            typing "EXIT" will return you to BC.
     Usage:
                         shell dir /w
                         shell cd \math
                         shell
     ______________________________________________________________________
     sin     Function
     ----------------------------------------------------------------------
     Returns: the sine of the argument in radians.
     Range: any number.
     Arguments: one.
                         sin 0 = 0
                         sin .5 = 0.4794255386

     ______________________________________________________________________
     sinh    Function
     ----------------------------------------------------------------------
     Returns: the hyperbolic sine of the argument in radians.
     Range: any number.
     Arguments: one.
                         sinh 0 = 0
                         sinh 1 = 1.175201194
     ______________________________________________________________________
     sqr     Function
     ----------------------------------------------------------------------
     Returns: the square root of the argument.
     Range: any positive number.
     Arguments: one.
                         sqr 25 = 5
                         sqr 16 = 4


     page 25
                                 ---T---
     ______________________________________________________________________
     tan     Function
     ----------------------------------------------------------------------
     Returns: the tangent of the argument in radians.
     Range: any number.
     Arguments: one.
                         tan 1 = 1.557407725
                         tan .5 = 0.5463024898

     ______________________________________________________________________
     tanh    Function
     ----------------------------------------------------------------------
     Returns: the hyperbolic tangent of the argument in radians.
     Range: any number.
     Arguments: one.
                         tanh 1 = 0.761594156
                         tanh .5 = 0.4621171573



     page 26
                                 ---W---
     ______________________________________________________________________
     while   Keyword
     ----------------------------------------------------------------------
     Returns: nothing.
     Range: none.
     Arguments: two expressions separated by a conditional operator.
     Notes: You must terminate the while statement with a corresponding
            endwhile else the program will abort with an error message.
            You must be careful to increment the counter variable if you
            have one or you will get caught in an infinite loop.
     Usage:
                     'Demonstrates while and endwhile
                     a = 0
                     print "Multiplication Table to ten"
                     while a <= 10
                         print "-------" a"------"
                         b = 0
                         while b <= 10
                             print a "X" b "=" b*a
                             b = b + 1
                         endwhile
                         a = a + 1
                         print
                     endwhile
                     end





         ----------------end-of-author's-documentation---------------

                         Software Library Information:

                    This disk copy provided as a service of

                           Public (software) Library

         We are not the authors of this program, nor are we associated
         with the author in any way other than as a distributor of the
         program in accordance with the author's terms of distribution.

         Please direct shareware payments and specific questions about
         this program to the author of the program, whose name appears
         elsewhere in  this documentation. If you have trouble getting
         in touch with the author,  we will do whatever we can to help
         you with your questions. All programs have been tested and do
         run.  To report problems,  please use the form that is in the
         file PROBLEM.DOC on many of our disks or in other written for-
         mat with screen printouts, if possible.  PsL cannot debug pro-
         programs over the telephone, though we can answer questions.

         Disks in the PsL are updated  monthly,  so if you did not get
         this disk directly from the PsL, you should be aware that the
         files in this set may no longer be the current versions. Also,
         if you got this disk from another vendor and are having prob-
         lems,  be aware that  some files may have become corrupted or
         lost by that vendor. Get a current, working disk from PsL.

         For a copy of the latest monthly software library newsletter
         and a list of the 3,000+ disks in the library, call or write

                           Public (software) Library
                               P.O.Box 35705 - F
                            Houston, TX 77235-5705

                                 Orders only:
                                1-800-2424-PSL
                              MC/Visa/AmEx/Discover

                          Outside of U.S. or in Texas
                          or for general information,
                              Call 1-713-524-6394

                          PsL also has an outstanding
                          catalog for the Macintosh.


